#! /usr/bin/env python
#These lines can be added to .bashrc or .bash_profile
#Then source .bashrc or .bash_profile and the *.py files will be 
#executable from terminal

#BASIC_ANALYSIS_HOME
#export BASIC_ANALYSIS_HOME=<path_to_automatic_analysis_folder>
#export PATH=$PATH:$BASIC_ANALYSIS_HOME

#If you prefer to configure the path each time,
#please run python run_this_first.py

import pkg_resources

debug = False
 
if __name__ == ("__main__"):
    
    #Validating scipy:
    import scipy
    #version_scipy = scipy.__version__
    version_scipy = pkg_resources.get_distribution("scipy").version
    print "SciPy Version: %s"% str(version_scipy)
    
    if (debug):
        version_scipy = '0.11.1'
    if version_scipy >= '0.12.0':
        scipy_module = True
    else:
        scipy_module = False
        print ("Version Scipy must be >= 0.12.0")         

    #Validating numpy:
    import numpy
    #version_numpy = numpy.__version__
    version_numpy = pkg_resources.get_distribution("numpy").version
    print "numPy Version: %s"% str(version_numpy)
 
    if (debug):
        version_numpy = '1.6.1'
    if version_numpy >= '1.6.2':
        numpy_module = True
    else:
        numpy_module = False
        print ("Version NumPy should be >= 1.6.2")         

    #Validating lmfit:
    import lmfit
    #version_lmfit = lmfit.__version__
    version_lmfit = pkg_resources.get_distribution("lmfit").version
    print "lmfit Version: %s"% str(version_lmfit)
    
    if (debug):
        version_lmfit = '0.7.1'
    if version_lmfit >= '0.7.2':
        lmfit_module = True
    else:
        lmfit_module = False
        print ("Version lmfit should be >= 0.7.2")         

    #This does not work. In consequence, I'll call it through shell
    #This does not work. In consequence, I'll call it through shell
    #-------------------------------------------------------------------------
    #scripts_folder = '/usr/local/automatic_analysis'
    #os.environ['BASIC_ANALYSIS_HOME'] = scripts_folder
    #os.environ['PATH'] = os.environ['PATH'] + ':' + \
    #                     os.environ['BASIC_ANALYSIS_HOME'] 
    ##print( os.environ['PATH'] + ':' + os.environ['BASIC_ANALYSIS_HOME'] )
    #print os.environ['PATH']

    if (lmfit_module == False) or (numpy_module == False) or \
       (scipy_module == False):
        print ("\n")
        print (" One or more modules are not updated.")
        print (" Please update them and try again.")
        print ("\n")
    else:
        print ("\n")
        print ("All dependencies are OK.")
        print ("Please execute ./setup.sh to set the enviromental variable.")
        print ("\n")
