#! /usr/bin/env python
#####################################################################################
###             Function to generate the .gnuplot file
#####################################################################################
def genGNUPlotfile(measured_file, name): 
    
    print '\n\n===> Fundamental Factors'

    if (name == 'time'):
        gnuplot_file     = measured_file[:-4] + '.FundamentalFactors.gnuplot'
    elif (name == 'cycles'):
        gnuplot_file     = measured_file[:-4] + '.FundamentalFactors.gnuplot'
    
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Model Factors Summary\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:1.1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:3 lt 1 lc 1 ps 2.5 title \"Load Balance\",'%measured_file)
        f.write('\'%s\' using 1:4 lt 2 lc 2 ps 2.5 title \"Serialization\",' %measured_file)
        f.write('\'%s\' using 1:5 lt 3 lc 3 ps 2.5 title \"Transfer\",' %measured_file)
        f.write('\'%s\' using 1:6 lt 4 lc 4 ps 2.5 title \"Parallel Efficiency\"\n'  %measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genSpeedupGraph(measured_file):
    print '===> Speedup Graph'
    gnuplot_file = measured_file[:-4] + '.Speedup.gnuplot'
    
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Time Efficiency\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:1.1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:15 pt 3 ps 2.5 title \"Speedup\"\n'%measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
        
    f.close()
    print "File %s has been created  \n\n" %gnuplot_file[2:]

def genEffGraph(measured_file):
    print '===> Sanity Checks (Time, IPC, Instructions, and Cycles per us)'
    
    gnuplot_file = measured_file[:-4] + '.OtherEfficiencyFactors.gnuplot'

    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Overall Efficiency\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:1.1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:15 ps 2.5 title \"Speedup\",'%measured_file)
        f.write('\'%s\' using 1:13 ps 2.5 title \"IPC\",' %measured_file)
        f.write('\'%s\' using 1:14 ps 2.5 title \"Instructions\",' %measured_file)
        f.write('\'%s\' using 1:19 ps 2.5 title \"Cycles per us (useful)\",' %measured_file)
        f.write('\'%s\' using 1:21 ps 2.5 pt 6 title \"Cycles per us\"\n'  %measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
    
    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genLBGraph(measured_file):
    print '===> LB graph (LB, Ser, LB_ipc and LB_ui)'
    
    gnuplot_file     = measured_file[:-4] + '.LoadBalances.gnuplot'
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Load Balances\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:1.1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:3 ps 2.5 title \"Load Balance Time\",'%measured_file)
        f.write('\'%s\' using 1:24 ps 2.5 title \"Load Balance Instructions\",' %measured_file)
        f.write('\'%s\' using 1:25 ps 2.5 title \"Load Balance IPC\",' %measured_file)
        f.write('\'%s\' using 1:4 ps 2.5 title \"Serialization\"\n'  %measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
        
    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genP2PGraph(measured_file):
    print '===> P2P communications (bytes, calls)'
    
    gnuplot_file     = measured_file[:-4] + '.P2PCommunications.gnuplot'
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"P2P Communications\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data linespoints\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:29 lw 1.5 title \"Ratio of Maximum num of P2P calls\",'%measured_file)
        f.write('\'%s\' using 1:30 lw 1.5 title \"Load Balance in num of P2P calls\",' %measured_file)
        f.write('\'%s\' using 1:32 lw 1.5 title \"Ratio of Maximum num of bytes sent\",' %measured_file)
        f.write('\'%s\' using 1:33 lw 1.5 title \"Load Balance of num of bytes sent\"\n'  %measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
        
    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genCollectivesGraph(measured_file):
    print '===> Collective communications (bytes, calls)'
    
    gnuplot_file     = measured_file[:-4] + '.CollectiveCommunications.gnuplot'
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Collective Communications\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:1.1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data linespoints\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:35 lw 1.5 title \"Ratio of Num. collective calls\",'%measured_file)
        f.write('\'%s\' using 1:37 lw 1.5 title \"Ratio of Avg. bytes per call\",' %measured_file)
        f.write('\'%s\' using 1:39 lw 1.5 title \"Ratio of Max bytes per call\",' %measured_file)
        f.write('\'%s\' using 1:40 lw 1.5 title \"Balance in bytes\"\n'  %measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
        
    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]
     
def genRateGraph(measured_file):
    print '===> Inst ratio vs IPC'
    
    gnuplot_file     = measured_file[:-4] + '.InstratevsIPC.gnuplot'
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Instructions and IPC\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:1.1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data linespoints\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:14 lw 2.5 lc rgb "#008B8B" title \"Efficiency Instructions\",'%measured_file)
        f.write('\'%s\' using 1:13 lw 2.5 lc rgb "#9400D3" title \"Efficiency IPC\"\n'  %measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')

    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genTimeGraph(measured_file):
    print '===> Elapsed Time'
    
    gnuplot_file = measured_file[:-4] + '.ElapsedTime.gnuplot'   
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Time\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Time (s)\' \n')
        f.write('\n')
        f.write('set xrange [1:]\n')
        f.write('set yrange [0:]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:10  pt 3 ps 2.5 title \"Time (s)\"\n'%measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
        
    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genCyclesGraph(measured_file):
    print '===> Cycles per usec'
    
    gnuplot_file = measured_file[:-4] + '.CyclesperUs.gnuplot'
    name = measured_file[:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Cycles per usecs\\n{%s}\" \n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Cycles\' \n')
        f.write('\n')
        f.write('set xrange [:]\n')
        f.write('set yrange [0:]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        f.write('set key bottom right inside\n')
        f.write('\n')
        f.write('set style data linespoints\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:18 lc 4 lw 1.5 title \"Cycles per us useful\",'%measured_file)
        f.write(' \'%s\' using 1:20 lc 5 lw 1.5 title \"Cycles per us\"\n'%measured_file)
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')
    
    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genGNUPlotfileFactorsPredicted(prediction_file, fits, Ps):

    gnuplot_file     = prediction_file[:-4] + '.ALLMODELFACTORSprediction.gnuplot'
    name = prediction_file[2:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write("#set border lw 3.5 \n")
        f.write("set lmargin 9 \n")
        f.write("set bmargin 3 \n")
        f.write("set rmargin 3 \n")
        f.write("set tmargin 3 \n")
        f.write('\n')
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Extrapolation of Fundamental Factors\\n{%s}\"\n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:1000000]\n')
        f.write('set yrange [0:1.2]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        #  f.write('set grid linewidth 0.5\n')
        #  f.write('set border lw 1\n')
        f.write('set key left bottom inside\n')
        f.write('\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:3 lt 1 lc 1 ps 2.5 title \"Load Balance (%s.%s)\",'%(prediction_file, fits[2], Ps[2]))
        f.write('\'%s\' using 1:4 lt 2 lc 2 ps 2.5 title \"Serialization (%s.%s)\",' %(prediction_file, fits[0], Ps[0]))
        f.write('\'%s\' using 1:5 lt 3 lc 3 ps 2.5 title \"Transfer (%s.%s)\",' %(prediction_file, fits[1], Ps[1]))
        f.write('\'%s\' using 1:2 lt 4 lc 4 ps 2.5 title \"Parallel Efficiency\"\n'  %prediction_file)
        #  f.write('quit\n') #close the gnuplot window
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')

    f.close()
    print "File %s has been created \n\n" %gnuplot_file[2:]

def genGNUPlotfilePrediction(measured_file, prediction_file, fits, Ps):
    gnuplot_file     = prediction_file[:-4] + '_Pred_vs_Meas.gnuplot'
    name = prediction_file[2:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write("#set border lw 3.5 \n")
        f.write("set lmargin 9 \n")
        f.write("set bmargin 3 \n")
        f.write("set rmargin 3 \n")
        f.write("set tmargin 3 \n")
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Comparison of Predicted and Measured Fundamental Factors\\n{%s}\"\n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:1000000]\n')
        f.write('set yrange [0:1.2]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        #  f.write('set grid linewidth 0.5\n')
        #  f.write('set border lw 1\n')
        f.write('set key left bottom inside\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:3  lt 5 ps 0.5 lc 1 lw 1.5 title \"Load Balance (%s.%s)\" with linespoints,'%(prediction_file, fits[2], Ps[2]))
        f.write('\'%s\' using 1:3 lt 1 lc 1 ps 2 title \"Measured Load Balance\",' %measured_file)
        f.write('\'%s\' using 1:4 ps 0.5 lt 5 lc 2 lw 1.5 title \"Serialization (%s.%s)\" with linespoints,' %(prediction_file, fits[0], Ps[0]))
        f.write('\'%s\' using 1:4 lt 2 lc 2 ps 2 title \"Measured Serialization\",' %measured_file)
        f.write('\'%s\' using 1:5 ps 0.5 lt 5 lc 3 lw 1.5 title \"Transfer (%s.%s)\" with linespoints,' %(prediction_file, fits[1], Ps[1]))
        f.write('\'%s\' using 1:5 lt 3 lc 3 ps 2 title \"Measured Transfer\",'  %measured_file)
        f.write('\'%s\' using 1:2 ps 0.5 lt 5 lc 4 lw 1.5 title \"Model Parallel Eff.\" with linespoints,' %prediction_file)
        f.write('\'%s\' using 1:6 lt 4 lc 4 ps 2 title \"Measured Parallel Eff.\"\n'  %measured_file)
        #  f.write('quit\n') #close the gnuplot window
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')

    f.close()
    print "File %s has been created \n\n" %gnuplot_file
    
def genGNUPlotfileGlobalPred(measured_file, prediction_file, fits, Ps):
    gnuplot_file     = prediction_file[:-4] + '_GlobalPred.gnuplot'
    name = prediction_file[2:-4]
    pngname = gnuplot_file[:-7] + 'png'
    
    with open(gnuplot_file, "w") as f:
        f.write("#set terminal pngcairo size 1280, 1024 enhanced font \"Helvetica, 24\" \n")
        f.write("#set output \"%s\" \n"%pngname)
        f.write('set datafile separator ","\n')
        f.write('\n')
        f.write("set title \"Global Prediction based in all the efficiencies\\n{%s}\"\n"%name)
        f.write('set xlabel \'Processes\' \n')
        f.write('set ylabel \'Efficiency\' \n')
        f.write('\n')
        f.write('set xrange [1:1000000]\n')
        f.write('set yrange [0:1]\n')
        f.write('set logscale x 10\n')
        f.write('\n')
        #  f.write('set grid linewidth 0.5\n')
        #  f.write('set border lw 1\n')
        f.write('set key left bottom inside\n')
        f.write('set style data points\n')
        f.write('\n')
        f.write('plot \'%s\' using 1:7  lt 5 ps 0.5 lc rgb "#008B8B" lw 1.5 title \"Instructions Eff (%s.%s)\" with linespoints,'%(prediction_file, fits[4], Ps[4]))
        f.write('\'%s\' using 1:14 lt 1 lc rgb "#008B8B" ps 2 title \"Measured Instructions Eff\",' %measured_file)
        f.write('\'%s\' using 1:8 ps 0.5 lt 5 lc rgb "#9400D3" lw 1.5 title \"IPC Eff (%s.%s)\" with linespoints,' %(prediction_file, fits[3], Ps[3]))
        f.write('\'%s\' using 1:13 lt 2 lc rgb "#9400D3" ps 2 title \"Measured IPC Eff\",' %measured_file)
        f.write('\'%s\' using 1:2 ps 0.5 lt 5 lc 4 lw 1.5 title \"Model Parallel Eff\" with linespoints,' %prediction_file)
        f.write('\'%s\' using 1:6 lt 4 lc 4 ps 2 title \"Measured Parallel Eff\",'  %measured_file)
        f.write('\'%s\' using 1:9 ps 0.5 lt 5 lc rgb "#00FF7F" lw 1.5 title \"Global Model Eff.\" with linespoints,' %prediction_file)
        f.write('\'%s\' using 1:41 lt 3 lc rgb "#00FF7F" ps 2 title \"Global Measured Eff.\"\n'  %measured_file)
        #  f.write('quit\n') #close the gnuplot window
        f.write('\n')
        f.write('pause -1 "Press return to continue..."\n')

    f.close()
    print "File %s has been created \n\n" %gnuplot_file
